#ifndef przedmiotyconst_h
#define przedmiotyconst_h

#include "przedm.h"

#define JEDZENIE		1 << 0
#define KUPIONE			1 << 1
#define NIE_POKAZUJ_MATERIALU	1 << 2
#define KOPIOWANY		1 << 3
#define CZESC			1 << 4
#define ZIDENTYFIKOWANY		1 << 5

/* XXX bez CZESC */
#define WSZYSTKIE_FLAGI		JEDZENIE | KUPIONE | NIE_POKAZUJ_MATERIALU | KOPIOWANY | ZIDENTYFIKOWANY

/* Klasy przedmiotw: */

#define KL_BR_JEDN		1 << 0
#define  PODKL_MIECZ		0
#define  PODKL_NOZ		1
#define  PODKL_DZIDA		2
#define  PODKL_MLOT		3
#define  PODKL_TOPOR		4
#define  PODKL_KIJ		5
#define KL_BR_DWUR		1 << 1
#define  PODKL_MIECZ_DWUR	0
#define  PODKL_KIJ_DWUR	1
#define KL_LUK			1 << 2
#define KL_KUSZA		1 << 3
#define KL_JEDZENIE		1 << 4
#define KL_NAKR_GLOWY		1 << 5
#define KL_PANCERZ		1 << 6
#define  PODKL_BIELIZNA		0
#define  PODKL_KOLCZUGA		1
#define  PODKL_PANCERZ		2
#define  PODKL_SZATA		3
#define KL_KSIAZKA		1 << 7
#define KL_ZLOTO		1 << 8
#define KL_ROZNE		1 << 9
#define KL_BUTY			1 << 10
#define KL_TARCZE		1 << 11
#define KL_ZWOJ			1 << 12
#define KL_NAPOJ		1 << 13
#define KL_AMUNICJA		1 << 14
#define  PODKL_STRZALY		0
#define  PODKL_BELTY		1
#define  PODKL_KAMIENIE		2


#define KL_WSZYSTKIE		KL_BR_JEDN | KL_BR_DWUR | KL_LUK | KL_KUSZA | KL_JEDZENIE | KL_NAKR_GLOWY | KL_PANCERZ | KL_KSIAZKA | KL_ZLOTO | KL_ROZNE | KL_BUTY | KL_TARCZE | KL_ZWOJ | KL_NAPOJ | KL_AMUNICJA
/* Materiay: */
#define MAT_PLOTNO		0
#define MAT_SKORA		1
#define MAT_UTWARDZONA_SKORA	2
#define MAT_DREWNO		3
#define MAT_JEDWAB		4
#define MAT_SZKLO		5
#define MAT_KRYSZTAL		6
#define MAT_URAN		7
#define MAT_PAPIER		8
#define MAT_BRAZ		9
#define MAT_ZELAZO		10
#define MAT_STAL		11
#define MAT_SREBRO		12
#define MAT_ZLOTO		13
#define MAT_CYNA		14
#define MAT_OLOW		15
#define MAT_ZELIWO		16
#define MAT_MIEDZ		17
#define MAT_CYNK		18
#define MAT_MOSIADZ		19
#define MAT_TYTAN		20
#define MAT_IRYD		21
#define MAT_KEVLAR		22
#define MAT_KRYPTONIT		23
#define MAT_ADAMANIT		24
#define MAT_JEDZENIE		25

/* Gramatyka */
#define LCZ_POJEDYNCZA	0
#define LCZ_MNOGA	1
#define LCZ_MNOGA_II	2

#define RDZ_MESKI	0
#define RDZ_ZENSKI	1
#define RDZ_NIJAKI	2

#define PRZYP_MIANOWNIK	0
#define PRZYP_BIERNIK	1
#endif
