/* punkty.h */
#ifndef punkty_h
#define punkty_h

#include <time.h>
#include "config.h"
#include "io.h"
#include "ekran.h"

FILE *plik_z_hiscore;
char sciezka_do_hiscore[1000];
unsigned long int punkty;	/* Punkty wynikajce ze wspczynnikw, expa itd. (tj. dajce si policzy w kadej chwili */
unsigned long int punkty_extra;	/* Punkty dodatkowe - za wykonanie zada itd. */

struct pozycja {
    char nazwa[50];
    unsigned long int punkty;	/* -1, jeli nieaktywna pozycja */
    time_t czas;
    int rasa, klasa, plec;
    char powod[1000];
} hiscore[MAXPOZYCJI];

void init_punktow();
void dodaj_punkty(int ile);	/* Zwiksza punkty_extra */
unsigned long int policz_punkty();	/* Liczy punkty i zwraca sum punkty+punkty_extra */
void wczytaj_punkty();
void zapisz_punkty();

/* Umieszcza wynik w tablicy wynikw; zwraca numer indeksu tablicy, albo -1, jeeli si nie zaapa */
int umiesc_w_tablicy();
void wyswietl_punktacje(int podswietl);
#endif
