/*structpoziom.h */
#ifndef struct_poziom_h
#define struct_poziom_h

#include "config.h"

#define Gracz Poziom.Istoty.poczatek->nast

#include "poziomconst.h"
#include "teren.h"
#include "structprzedmioty.h"
#include "structpostac.h"

unsigned char lut[MAXX][MAXY][2];

struct poziom {
    int pole[MAXX][MAXY];

    int maxx, maxy;
    int sx, sy;			/* "startowe"... */

    int kx, ky;			/* "kocowe"...   w wPoziom jest widoczne okienko (sx,sy,kx,ky) */

    int poczx, poczy;		/* wsprzdne startu postaci */
    /* (o ile ustawa nie przewiduje inaczej (a zwykle przewiduje)) */

    char znane[MAXX][MAXY];	/* co wywietla, bo odkryte */
    char widoczne_gracz[MAXX][MAXY];	/* co widzi gracz */
    char widoczne_potwor[MAXX][MAXY];	/* co widzi potwr */
    wsk_istota ostatnio_liczona_widocznosc;
    int poziom;			/* Poziom trudnoci */

    struct przedmioty Przedmioty;
    struct istoty Istoty;
    char nazwa[5];		/* nazwa poziomu */

} Poziom;

/* Skrcona wersja, do trzymania w plikach */
struct poziom_IO {
    char pole[MAXX][MAXY];
    int maxx, maxy;
    int poczx, poczy;
    struct istota_IO istota[MAXPOTW];
    struct przedmiot_IO przedmiot[MAXPOTW + 1];	/* przedmioty_IO[MAXPOTW+1]
						   le sobie na planszy */

};

#endif
