/* umiejetnosci.c */
#include "umiejetnosci.h"

void init_umiejetnosci()
{
    int l;
    for (l = 0; l < ILOSC_UMIEJETNOSCI; l++)
	tab_um[l] = NULL;
    dodaj_umiejetnosc(UM_WALKA, -1, SILA, 1);
    dodaj_umiejetnosc(UM_BRON_JEDN, UM_WALKA, ZRECZNOSC, 1);
    dodaj_umiejetnosc(UM_BRON_DWUR, UM_WALKA, SILA, 1);
    dodaj_umiejetnosc(UM_WALKA_BEZ_BRONI, UM_WALKA, SILA, 1);
    dodaj_umiejetnosc(UM_TARCZE, UM_WALKA, ZRECZNOSC, 1);
    dodaj_umiejetnosc(UM_MIECZ, UM_BRON_JEDN, ZRECZNOSC, 1);
    dodaj_umiejetnosc(UM_NOZ, UM_BRON_JEDN, ZRECZNOSC, 1);
    dodaj_umiejetnosc(UM_DZIDA, UM_BRON_JEDN, SILA, 1);
    dodaj_umiejetnosc(UM_MLOT, UM_BRON_JEDN, SILA, 1);
    dodaj_umiejetnosc(UM_TOPOR, UM_BRON_JEDN, SILA, 1);
    dodaj_umiejetnosc(UM_KIJ, UM_BRON_JEDN, SILA, 1);
    dodaj_umiejetnosc(UM_MIECZ_DWUR, UM_BRON_DWUR, SILA, 1);
    dodaj_umiejetnosc(UM_KIJ_DWUR, UM_BRON_DWUR, SILA, 1);
    dodaj_umiejetnosc(UM_SPORT, -1, SILA, 1);
    dodaj_umiejetnosc(UM_PLYWANIE, UM_SPORT, SILA, 0);
    dodaj_umiejetnosc(UM_BIEGANIE, UM_SPORT, SILA, 1);
    dodaj_umiejetnosc(UM_SKOKI, UM_SPORT, SILA, 1);
    dodaj_umiejetnosc(UM_NAUKA, -1, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_LITERATURA, UM_NAUKA, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_CZYTANIE, UM_LITERATURA, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_PISANIE, UM_LITERATURA, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA, -1, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_OGOLNA, UM_MAGIA, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_SMIERCI, UM_MAGIA, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_NATURY, UM_MAGIA, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_ZYCIA, UM_MAGIA, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_LECZNICZA, UM_MAGIA_ZYCIA, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_ZYWIOLOW, UM_MAGIA_NATURY, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_OGNIA, UM_MAGIA_ZYWIOLOW, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_WODY, UM_MAGIA_ZYWIOLOW, INTELIGENCJA, 0);
    dodaj_umiejetnosc(UM_MAGIA_POWIETRZA, UM_MAGIA_ZYWIOLOW, INTELIGENCJA,
		      0);
    dodaj_umiejetnosc(UM_MAGIA_ZIEMII, UM_MAGIA_ZYWIOLOW, INTELIGENCJA, 0);
}

char *nazwa_umiejetnosci(int ktorej, char *buf)
{
    switch (ktorej) {
    case UM_WALKA:
	strcpy(buf, _("Walka"));
	break;
    case UM_BRON_JEDN:
	strcpy(buf, _("Bronie jednorczne"));
	break;
    case UM_BRON_DWUR:
	strcpy(buf, _("Bronie dwurczne"));
	break;
    case UM_WALKA_BEZ_BRONI:
	strcpy(buf, _("Walka bez broni"));
	break;
    case UM_TARCZE:
	strcpy(buf, _("Tarcze"));
	break;
    case UM_MIECZ:
	strcpy(buf, _("Miecze"));
	break;
    case UM_NOZ:
	strcpy(buf, _("Noe i sztylety"));
	break;
    case UM_DZIDA:
	strcpy(buf, _("Dzidy"));
	break;
    case UM_MLOT:
	strcpy(buf, _("Moty"));
	break;
    case UM_TOPOR:
	strcpy(buf, _("Topory"));
	break;
    case UM_KIJ:
	strcpy(buf, _("Kije"));
	break;
    case UM_MIECZ_DWUR:
	strcpy(buf, _("Dwurczne miecze"));
	break;
    case UM_KIJ_DWUR:
	strcpy(buf, _("Dwurczne kije"));
	break;
    case UM_SPORT:
	strcpy(buf, _("Sport"));
	break;
    case UM_PLYWANIE:
	strcpy(buf, _("Pywanie"));
	break;
    case UM_BIEGANIE:
	strcpy(buf, _("Biegi"));
	break;
    case UM_SKOKI:
	strcpy(buf, _("Skoki"));
	break;
    case UM_NAUKA:
	strcpy(buf, _("Nauka"));
	break;
    case UM_LITERATURA:
	strcpy(buf, _("Literatura"));
	break;
    case UM_CZYTANIE:
	strcpy(buf, _("Czytanie"));
	break;
    case UM_PISANIE:
	strcpy(buf, _("Pisanie"));
	break;
    case UM_MAGIA:
	strcpy(buf, _("Magia"));
	break;
    case UM_MAGIA_OGOLNA:
	strcpy(buf, _("Magia oglna"));
	break;
    case UM_MAGIA_SMIERCI:
	strcpy(buf, _("Magia mierci"));
	break;
    case UM_MAGIA_NATURY:
	strcpy(buf, _("Magia natury"));
	break;
    case UM_MAGIA_ZYWIOLOW:
	strcpy(buf, _("Magia ywiow"));
	break;
    case UM_MAGIA_OGNIA:
	strcpy(buf, _("Magia ognia"));
	break;
    case UM_MAGIA_WODY:
	strcpy(buf, _("Magia wody"));
	break;
    case UM_MAGIA_POWIETRZA:
	strcpy(buf, _("Magia powietrza"));
	break;
    case UM_MAGIA_ZIEMII:
	strcpy(buf, _("Magia ziemi"));
	break;
    case UM_MAGIA_ZYCIA:
	strcpy(buf, _("Magia ycia"));
	break;
    case UM_MAGIA_LECZNICZA:
	strcpy(buf, _("Magia lecznicza"));
	break;
    default:
	strcpy(buf, _("Dziwna umiejtno"));
	break;
    }
    return buf;
}

void wyswietl_umiejetnosci(struct istota *Postac)
{
    int l;
    char tmp[2000], tmp2[100], tmp3[100];
    tmp[0] = '\0';
    for (l = 0; l < ILOSC_UMIEJETNOSCI; l++)
	if (Postac->umiejetnosci[l]) {
	    sprintf(tmp2, "^3 %-20s:^5 %3d[%3d]^4\n",
		    nazwa_umiejetnosci(l, tmp3), Postac->umiejetnosci[l],
		    Postac->umiejetnosci_teor[l]);
	    strcat(tmp, tmp2);
	}
    wyswietl_tekst(tmp);
}

void dodaj_umiejetnosc(int nr, int nr_rodzica, int cecha, int dozw)
{
    int l;
    wsk_um umiej = my_malloc(sizeof(struct umiejetnosc));
    assert(tab_um[nr] == NULL);
    tab_um[nr] = umiej;
    umiej->nr = nr;
    if (nr_rodzica == -1) {
	umiej->nadum = NULL;
    } else {
	assert(tab_um[nr_rodzica]);
	umiej->nadum = tab_um[nr_rodzica];
	tab_um[nr_rodzica]->podum[tab_um[nr_rodzica]->ile_podum] = umiej;
	tab_um[nr_rodzica]->ile_podum++;
    }
    umiej->cecha = cecha;
    umiej->dozwolona = dozw;
    umiej->ile_podum = 0;
    for (l = 0; l < MAXPODUM; l++)
	umiej->podum[l] = NULL;
}

void
cwicz_umiejetnosc(struct istota *Postac, wsk_um umiejetnosc,
		  wsk_um poza_ktora, int o_ile, int praktycznie)
{
    int l, wsp, wsp2;
    if (!(umiejetnosc->dozwolona)
	&& !(Postac->umiejetnosci[umiejetnosc->nr]))
	return;
    wsp = (100 - Postac->umiejetnosci[umiejetnosc->nr]);
    if (wsp < 0)
	wsp = 0;
    if (praktycznie) {		/* wiczymy praktycznie */
	wsp2 =
	    o_ile + Postac->wspolczynniki[umiejetnosc->cecha] / 4 +
	    wsp / 6;
	Postac->umiejetnosci_male[umiejetnosc->nr] +=
	    losowaoddo(wsp2 / 2, 3 * wsp2 / 2);
	if (Postac->umiejetnosci_male[umiejetnosc->nr] > 10000) {
	    Postac->umiejetnosci[umiejetnosc->nr] +=
		Postac->umiejetnosci_male[umiejetnosc->nr] / 10000;
	    Postac->umiejetnosci_male[umiejetnosc->nr] %= 10000;
	    if (Postac->umiejetnosci[umiejetnosc->nr] >
		Postac->umiejetnosci_teor[umiejetnosc->nr])
		Postac->umiejetnosci[umiejetnosc->nr] =
		    Postac->umiejetnosci_teor[umiejetnosc->nr];
	}
    } else {			/* Uczymy si teoretycznie */
	wsp2 =
	    o_ile + Postac->wspolczynniki[umiejetnosc->cecha] / 4 +
	    wsp / 6;
	Postac->umiejetnosci_teor_male[umiejetnosc->nr] +=
	    losowaoddo(wsp2 / 2, 3 * wsp2 / 2);
	if (Postac->umiejetnosci_teor_male[umiejetnosc->nr] > 10000) {
	    Postac->umiejetnosci_teor[umiejetnosc->nr] +=
		Postac->umiejetnosci_teor_male[umiejetnosc->nr] / 10000;
	    Postac->umiejetnosci_teor_male[umiejetnosc->nr] %= 10000;
	}
    }
    if (umiejetnosc->ile_podum) {
	for (l = 0; l < umiejetnosc->ile_podum; l++)
	    if (umiejetnosc->podum[l] != poza_ktora)
		cwicz_umiejetnosc(Postac, umiejetnosc->podum[l],
				  umiejetnosc, o_ile, 0);
    }
    if (umiejetnosc->nadum && umiejetnosc->nadum != poza_ktora)
	cwicz_umiejetnosc(Postac, umiejetnosc->nadum, umiejetnosc,
			  o_ile / 10, 0);
}

/* Zwraca warto zalen od kontekstu zwizan z wykonywan umiejtnoci */
int uzyj_umiejetnosci(struct istota *Postac, int umiejetnosc)
{
    int wynik, tmp, wyn;
    switch (umiejetnosc) {
    case UM_PLYWANIE:
	wyn = wynik = 0;
	tmp = losowa100();
	if (tmp > Postac->umiejetnosci[UM_PLYWANIE]) {
	    wyn = (tmp - Postac->umiejetnosci[UM_PLYWANIE]);
	}
	if (!Postac->umiejetnosci[UM_PLYWANIE]) {
	    if (Postac->flagi & FLAGA_GRACZA)
		dodaj_napis(_("Przecie nie umiesz pywa! "));
//          zmien_en(Postac, -6000);
	} else {
	    if (Postac->flagi & FLAGA_GRACZA)
		przesun_okienko(Postac, &Poziom);
	    if (!wyn) {
		wynik = 1;
		if (Postac->flagi & FLAGA_GRACZA) {
		    dodaj_napis(_("Pyniesz. "));
		} else {
		    char kom[100];
		    kom[0] = '\0';
		    if (Poziom.widoczne_gracz[Postac->x][Postac->y]) {
			strcat(kom, Postac->nazwa);
			strcat(kom, _(" pynie. "));
			dodaj_napis(kom);
		    }
		}
		zmien_en(Postac, -500);
	    } else {
		if (Postac->flagi & FLAGA_GRACZA) {
		    dodaj_napis(_("Toniesz! "));
		} else {
		    char kom[100];
		    kom[0] = '\0';
		    if (Poziom.widoczne_gracz[Postac->x][Postac->y]) {
			strcat(kom, Postac->nazwa);
			strcat(kom, _(" tonie. "));
			dodaj_napis(kom);
		    }
		}
		if (zmien_hp
		    (Postac,
		     -(tmp /
		       losowa(10 -
			      (Postac->umiejetnosci[UM_PLYWANIE]) %
			      10))) != ZYJE) {
		    if (Postac->flagi & FLAGA_GRACZA) {
			strcat
			    (powod_smierci,
			     _("Nadmiar wody w organimie... "));
		    } else {
			char kom[100];
			kom[0] = '\0';
			if (Poziom.widoczne_gracz[Postac->x][Postac->y]) {
			    strcat(kom, Postac->nazwa);
			    strcat(kom, _(" si utopi... "));
			    dodaj_napis(kom);
			}
		    }
		}

		zmien_en(Postac, -1000);
	    }
	}
/*	if (Poziom.pole[Postac->x][Postac->y] != WODA)
	    wynik = 1; */
	break;
    case UM_MIECZ:
    case UM_NOZ:
    case UM_DZIDA:
    case UM_MIECZ_DWUR:
    case UM_KIJ:
    case UM_KIJ_DWUR:
    case UM_MLOT:
	wynik = losowa(Postac->umiejetnosci[umiejetnosc]);
	break;
    case UM_CZYTANIE:
	wynik = Postac->umiejetnosci[umiejetnosc];
	break;
    case UM_TARCZE:
	wynik = Postac->umiejetnosci[umiejetnosc];
    default:
	wynik = 0;
    }
    cwicz_umiejetnosc(Postac, tab_um[umiejetnosc], NULL, 100, 1);
    return wynik;
}
