/* potwor.h */
#ifndef potwor_h
#define potwor_h

#include "config.h"
#include "io.h"
#include "structpotwor.h"
#include "structpostac.h"
#include "postac.h"

long int licznik_szybkosci;
long int max_szybkosc;

bool zajete[MAXX][MAXY];		/* Czy pole jest zajte przez jakiego potwora */

bool policzona_widocznosc;

void wczytaj_tablice_potw_ID(struct _plik *in, struct PotworyID *tablica);

void zapisz_tablice_potw_ID(char *out, long int *ile,
			    struct PotworyID *tablica);

void wczytaj_potwory(struct _plik *in, struct istoty *Istoty);

void wczytaj_schematy_anatomii(struct _plik *in);

void zapisz_potwory(char *out, long int *ile, struct istoty *Istoty);

void wczytaj_potwory_kr(struct _plik *in, struct istoty *Istoty);

void zapisz_potwory_kr(char *out, long int *ile, struct istoty *Istoty);

void wyczysc_liste_potworow(struct istoty *Istoty);

void ruch_potwora(struct istota *Potwor, struct poziom *Poziom);

void zabij_potwora(struct istoty *Istoty, struct poziom *Poziom);
void odpadnij(struct istota *ktorej_odpadlo, struct przedmioty *Gdzie,
	      int miejsce_odpadniete);
void dajcie_mu_spokoj_on_nie_zyje(struct poziom *Poziom,
				  struct istota *trup, struct istota *atakujacy);
char *nazwa_klasy(int nr_klasy);
char *nazwa_rasy(int nr_rasy);
char *nazwa_plci(int nr_plci);
#endif
