#ifndef poziomconst_h
#define poziomconst_h

/* Pola */
#define DRZWI_ZAMKNIETE 0
#define DRZWI_OTWARTE 1
#define DRZWI_ZAMKNIETE_NA_KLUCZ 2
#define TRAWA 3
#define MUR 4
#define WODA 5
#define DROGA 6
#define PODLOGA 7
#define ZEJSCIE 8
#define WEJSCIE 9
#define KIBEL 10
#define OLTARZ 11
#define NIC 12
#define DRZEWO 13
#define LOZKO 14

/* Typy poziomw do wygenerowania */
#define P_LAS 0
#define P_POLA 1
#define P_SKALA 2
#define P_WODA 3
#define P_JASKINIA 4
#define P_OST_JASKINIA 5	/* Ostatnia jaskinia, tj. bez zejcia niej */


/* Flagi poziomw */
#define PRZYBYWAJA_POTWORY	1 << 0
#define GENEROWANE_POTWORY	1 << 1
#define GENEROWANE_PRZEDMIOTY	1 << 2

/* Flagi terenu */
#define TER_MOZNA_WEJSC		1 << 0
#define TER_WIDAC_W_CIEMNOSCI	1 << 1
#define TER_TRAWA		1 << 2
#define TER_WODA		1 << 3
#define TER_MOZNA_OTWORZYC	1 << 4

#endif
