/* Rozne.h */
#ifndef ROZNE_H
#define ROZNE_H

#include "config.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "ekran_loc.h"

#ifdef OPT
char *old_loc;
char loc_env[50];
#endif

int losowa100();
int losowa10();
int losowa4();
int losowa(int max);
int losowaoddo(int min, int max);
void init_locale();
void end_locale();

static inline void *my_malloc(size_t size);
static inline void my_free(void *ptr);


static inline void *my_malloc(size_t size)
{
    void *ptr;
    if (!(ptr = malloc(size))) {
#ifdef LINUX
	fprintf(stderr, _("Nie mog zaalokowa %d bajtw.\n"), size);
#else
	fprintf(stderr, _("Nie mog zaalokowa %ld bajtw.\n"), size);
#endif
	return 0;
    }
    return ptr;
}

static inline void my_free(void *ptr)
{
    if (!ptr) {
	fprintf(stderr, _("Wywoano my_free(NULL).\n"));
    }
    free(ptr);
}

static inline void *debug_my_malloc(char *file, int l, char *f,
				    size_t size)
{
    void *ptr;
    if (!(ptr = malloc(size))) {
#ifdef LINUX
	fprintf(stderr, _("Nie mog zaalokowa %d bajtw (%s [%s:%d]).\n"),
		size, f, file, l);
#else
	fprintf(stderr,
		_("Nie mog zaalokowa %ld bajtw (%s [%s:%d]).\n"), size,
		f, file, l);
#endif
	return 0;
    }
    return ptr;
}

static inline void debug_my_free(char *file, int l, char *f, void *ptr)
{
    if (!ptr) {
	fprintf(stderr, _("Wywoano my_free(NULL) (%s [%s:%d]).\n"), f,
		file, l);
    }
    free(ptr);
}

#ifdef DEBUG
#ifndef __GNUC__
#define __PRETTY_FUNCTION__ "(unknown)"
#endif
#define my_malloc(size) debug_my_malloc (__FILE__, __LINE__, __PRETTY_FUNCTION__, size)
#define my_free(ptr) debug_my_free (__FILE__, __LINE__, __PRETTY_FUNCTION__, ptr)
#endif

#endif
