/*structpostac.h */
#ifndef struct_postac_h
#define struct_postac_h

#include "config.h"
#include "structprzedmioty.h"
#include "structzadanie.h"
#include "structpotwor.h"
#include "potwory.h"
#include "postacconst.h"

typedef struct istota *wsk_istota;

struct ekwipunek {
    struct przedmioty miejsce[MAXMEKW];
};

struct istota {
    char typ;			/* znaczek.... */

    int kolor;

    char nazwa[50];
    char nazwa_dop[50];		/*dopeniacz */

    int x, y;			/* analogicznie jak przedmiot */

    int ost_x, ost_y;

    int flagi;

    int rasa, klasa, plec;

    int zasieg_widzenia;	/*ile pl gay patrz */

    int szczescie;
    int schekw;

    struct przedmioty plecak;
    struct ekwipunek ekw;
    struct schemat_anatomii anatomia;
    struct Zadanie zadanie[MAXZD];

    int umiejetnosci[ILOSC_UMIEJETNOSCI];
    int umiejetnosci_male[ILOSC_UMIEJETNOSCI];	/* 1/1000 punkta */
    int umiejetnosci_teor[ILOSC_UMIEJETNOSCI];
    int umiejetnosci_teor_male[ILOSC_UMIEJETNOSCI];

    long int energia;		/* czy te: naarcie :) */

    long int energia_max;

    int szybkosc;

    int szybkosc_l;		/* licznik do systemu szybkoci */

    int wspolczynniki[ILOSC_WSPOLCZYNNIKOW];

    int hp, pp, hp_max, pp_max;

    int hp_tur, pp_tur;		/* Co ile tur regeneruje si 1 punkt */

    int hp_l, pp_l;		/* Liczniki... */

    int przyt, przyt_max, przyt_tur, przyt_l, psych, psych_max, psych_tur, psych_l;	/* Punkty przytomnoci i psychiczne */

    int ID;			/* indeks w tablicy waciwoci */

    int au;			/* kasa */

    int ost_x_celu, ost_y_celu;	/* Punkt do ktrego idziemy, (-1,-1), jeeli brak */

    int pancerz_nat;		/* Pancerz nie liczc przedmiotw */

    int exp;

    int poziom;

    int trasa;

    int obciazenie;		/* Aktualne */

    int obciazenie_max;

    int align;			/* -1000 - chaotyk
				   0 - neutralny 
				   1000 - praworzdny */

    int akcja;			/* Co konkretnego robi */

    int pozycja;

    short int wykonana;		/* Czy akcja ju wykonana */

    wskaznik_przedmiot przedmiot;	/* Przedmiot, ktrym si aktualnie zajmuje (np. towar) */

    wsk_istota istota;		/* Istota, ktr si aktualnie zajmuje (nie atakuje) (np. klient w sklepie) */

    wsk_istota cel_ataku;	/* kogo atakuje */

    wsk_istota nast;
    wsk_istota poprz;

} Istota;

struct istota_IO {
    char typ;			/* znaczek.... */

    int kolor;

    char nazwa[50];
    char nazwa_dop[50];		/*dopeniacz */

    int x, y;			/* analogicznie jak przedmiot */

    int flagi;

    int zasieg_widzenia;	/*ile pl gay patrz */

    int szczescie;

    int umiejetnosci[ILOSC_UMIEJETNOSCI];
    int umiejetnosci_male[ILOSC_UMIEJETNOSCI];
    int umiejetnosci_teor[ILOSC_UMIEJETNOSCI];
    int umiejetnosci_teor_male[ILOSC_UMIEJETNOSCI];

    int energia;		/* czy te: naarcie :) */

    int rasa, klasa, plec;

    int energia_max;

    int szybkosc;
    int pozycja;

    int pancerz, pancerz_nat;

    int au;

    int trasa;

    int akcja;

    int wspolczynniki[ILOSC_WSPOLCZYNNIKOW];

    int hp, pp, hp_max, pp_max;

    int hp_tur, pp_tur;		/* Co ile tur regeneruje si 1 punkt */

    int hp_l, pp_l;		/* Liczniki... */

    int przyt, przyt_max, przyt_tur, przyt_l, psych, psych_max, psych_tur, psych_l;	/* Punkty przytomnoci i psychiczne */

    int ID;

    int cel_ataku, istota, przedmiot;		/* indeksy w tablicy */

    struct schemat_anatomii anatomia;

};

struct istota_IO_krotka {
    int x, y, ID, trasa, akcja, akt_trasa, tr_start;
};

struct istoty {
    wsk_istota aktualny, poczatek, koniec;
    int ile;			/* ile istot */

    int maxszybkosc;		/* szybko najszybszej istoty na planszy */

} Istoty;
#endif
