/* convp.c (konwerter przedmiotw (z pliku napisanego po ludzku do tab_plik)) */
#define _GNU_SOURCE
#include <stdio.h>
#include "fake.h"

FILE *out, *lista, *przedmh;
int main(int argc, char *argv[])
{
    char tmp[1000];
    int i, j, k;
    if (!init_parser(argv[1])) {
	printf("Nie mog zainicjalizowa parsera!\n");
	exit(1);
    }
    out = fopen(argv[2], "wb");
    lista = fopen(argv[3], "wb");
    przedmh = fopen(argv[4], "wb");
    fprintf(przedmh,
	    "/* przedm.h */\n\n/* Plik generowany przez convp zawierajcy stae odpowiadajce odpowiednim przedmiotom */\n\n\n#ifndef PRZEDM_H\n#define PRZEDM_H\n\n");
    przedmiotyID.ile = 0;
    while (!ustaw_kawalek("{", "}")) {
	przedmiotyID.ID[przedmiotyID.ile].mat_sum = 0;
	for (i = 0; i < MAXMATERIALOW; i++) {
	    przedmiotyID.ID[przedmiotyID.ile].material[i][0] = 0;
	    przedmiotyID.ID[przedmiotyID.ile].material[i][1] = 0;
	    przedmiotyID.ID[przedmiotyID.ile].material[i][2] = 0;
	}
	i = parser_liczba("Ile_mat:", 1, 0, SP_LICZBA);
	if (!i) {
	    przedmiotyID.ID[przedmiotyID.ile].material[MAT_ZELAZO][0] = 1;
//              przedmiotyID.ID[przedmiotyID.ile].mat_sum=1;
	} else {
	    for (j = 0; j < i; j++) {
		int ktory;
		sprintf(tmp, "Mat%d:", j + 1);
		ktory = parser_liczba(tmp, 1, 0, SP_MAT);
		przedmiotyID.ID[przedmiotyID.ile].material[ktory][0] =
		    parser_liczba(tmp, 2, 1, SP_LICZBA);
		przedmiotyID.ID[przedmiotyID.ile].material[ktory][1] =
		    parser_liczba(tmp, 3, 0, SP_LICZBA);
		przedmiotyID.ID[przedmiotyID.ile].material[ktory][2] =
		    parser_liczba(tmp, 4, 0, SP_LICZBA);

//                    przedmiotyID.ID[przedmiotyID.ile].material[parser_liczba ("Mat:",2*j+1,0, SP_MAT)]=k=parser_liczba("Mat:",2*j+2,0, SP_LICZBA);
//                 
//      przedmiotyID.ID[przedmiotyID.ile].mat_sum+=k;
	    }
	}
	przedmiotyID.ID[przedmiotyID.ile].typ =
	    parser_znak("Znak:", 1, '@');
	strcpy(przedmiotyID.ID[przedmiotyID.ile].nazwa[PRZYP_MIANOWNIK],
	       parser_string(tmp, "Poj:", 1, "latajcy talerz"));
	for (k=1; k< MAXPRZYP; k++)
	strcpy(przedmiotyID.ID[przedmiotyID.ile].nazwa[k],
	       parser_string(tmp, "Poj:", k+1, przedmiotyID.ID[przedmiotyID.ile].nazwa[PRZYP_MIANOWNIK]));
	strcpy(przedmiotyID.ID[przedmiotyID.ile].mnoga,
	       parser_string(tmp, "Mn:", 1,
			     przedmiotyID.ID[przedmiotyID.ile].nazwa[PRZYP_MIANOWNIK]));
	strcpy(przedmiotyID.ID[przedmiotyID.ile].d_mnoga,
	       parser_string(tmp, "D_mn:", 1,
			     przedmiotyID.ID[przedmiotyID.ile].nazwa[PRZYP_MIANOWNIK]));
	parser_string(tmp, "Const:", 1, "FOOBAR");
	if (strcmp(tmp, "FOOBAR"))
	    fprintf(przedmh, "#define PRZ_%s %d\n", tmp, przedmiotyID.ile);
	przedmiotyID.ID[przedmiotyID.ile].rodzaj =
	    parser_liczba("Rdz:", 1, RDZ_MESKI, SP_RODZAJ);
	przedmiotyID.ID[przedmiotyID.ile].klasa_przedmiotu =
	    parser_liczba("Klasa:", 1, 0, SP_KL_PRZEDM);
	przedmiotyID.ID[przedmiotyID.ile].podklasa_przedmiotu =
	    parser_liczba("Podkl:", 1, -1, SP_PODKL_PRZEDM);
	/* XXX Stare wpisy _nie_ dziaaj. Trzeba _koniecznie_ wpisa sta, albo jej rwnowano (czyli nie np. 3, 5 tylko 8, 32) */
/* Stara metoda:	(1 << parser_liczba ("Klasa:", 1, 0, SP_KL_PRZEDM)); */
	przedmiotyID.ID[przedmiotyID.ile].czest =
	    parser_liczba("Czst:", 1, -1, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].waga =
	    parser_liczba("Waga:", 1, -1, SP_LICZBA);
/*	przedmiotyID.ID[przedmiotyID.ile].kolor =
	    parser_liczba("Kolor:", 1, 0, SP_KOLOR); */
	przedmiotyID.ID[przedmiotyID.ile].ile_min =
	    parser_liczba("Ile:", 1, 1, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].ile_max =
	    parser_liczba("Ile:", 2, 1, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].wrecz[0][0] =
	    parser_liczba("Wr1:", 1, 0, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].wrecz[0][1] =
	    parser_liczba("Wr1:", 2,
			  przedmiotyID.ID[przedmiotyID.ile].wrecz[0][0],
			  SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].wrecz[1][0] =
	    parser_liczba("Wr2:", 1, 0, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].wrecz[1][1] =
	    parser_liczba("Wr2:", 2,
			  przedmiotyID.ID[przedmiotyID.ile].wrecz[1][0],
			  SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].wrecz[2][0] =
	    parser_liczba("Wr3:", 1, 0, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].wrecz[2][1] =
	    parser_liczba("Wr3:", 2,
			  przedmiotyID.ID[przedmiotyID.ile].wrecz[2][0],
			  SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].mod_traf[0] =
	    parser_liczba("Mod_traf:", 1, 0, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].mod_traf[1] =
	    parser_liczba("Mod_traf:", 2,
			  przedmiotyID.ID[przedmiotyID.ile].mod_traf[0],
			  SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].flagi =
	    parser_liczba("Fl:", 1, 0, SP_FL_PRZEDM);
	przedmiotyID.ID[przedmiotyID.ile].pozywnosc =
	    parser_liczba("Po:", 1, 0, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].pancerz =
	    parser_liczba("Pnc:", 1, 0, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].cena =
	    parser_liczba("Cena:", 1, 0, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].poziom =
	    parser_liczba("Poz:", 1, 50, SP_LICZBA);
	przedmiotyID.ID[przedmiotyID.ile].wielkosc =
	    parser_liczba("Wielk:", 1, MAXWIELK, SP_LICZBA);
	fprintf(lista, "%d - %s\n", przedmiotyID.ile++,
		przedmiotyID.ID[przedmiotyID.ile].nazwa[PRZYP_MIANOWNIK]);
    }
    zapisz_tablice_prz_ID(out, przedmiotyID);
    fprintf(przedmh, "\n#endif\n");
    end_parser();
//  fcloseall ();
    return 0;
}
