/* fake.h */
/* Tu s rne rniaste funkcje (bd wydmuszki:) dla programw z katalogu utils */

#define fake_h
#define poziom_h
#define przedmioty_h
#define potwor_h
#include "structpoziom.h"
#include "structpostac.h"
#include "structprzedmioty.h"
#include "structprzedmiotyID.h"
#include "structpotwor.h"
#include "ekran_dod.h"
#include "io.h"
#include "trasy.h"
#include "parser.c"
#include "rozne.c"
#include "pulapki.h"

void rysuj_postac(struct istota *Istota, struct poziom *Poziom)
{
    return;
}

int pobierz_klawisz()
{
    return 0;
}

void ruch_postaci(struct istota *Postac, struct poziom *Poziom)
{
    return;
}

void usun_postac(struct istoty *Istoty)
{
    return;
}

int
dodaj_postac(int x, int y, int ID, int flagi, int poziom,
	     struct istoty *Istoty)
{
    return 0;
}

void wyczysc_liste_potworow(struct istoty *Istoty)
{
    return;
}

void poznaj_caly(struct poziom *Poziom)
{
    int x, y;
    for (x = 0; x < Poziom->maxx; x++)
	for (y = 0; y < Poziom->maxy; y++)
	    Poziom->znane[x][y] = TRUE;
}

void
poznaj_linie(struct poziom *Poziom, struct istota *Postac, int x1,
	     int y1, int x2, int y2)
{
    return;
}

void poznaj(struct poziom *Poziom, struct istota *Postac)
{
    return;
}

void zabij_potwora(struct istoty *Istoty, struct poziom *Poziom)
{
    return;
}

int
dodaj_ladnie(int x, int y, int ilosc, int ID, int flagi, int cena,
	     struct przedmioty *Przedmioty)
{
    return 0;
}

int tlumacz_char_na_int(char in)
{
    int out;
    switch (in) {
    case '+':
	out = DRZWI_ZAMKNIETE;
	break;
    case '/':
	out = DRZWI_OTWARTE;
	break;
    case '=':
	out = DRZWI_ZAMKNIETE_NA_KLUCZ;
	break;
    case '"':
	out = TRAWA;
	break;
    case '#':
	out = MUR;
	break;
    case '~':
	out = WODA;
	break;
    case '.':
	out = DROGA;
	break;
    case ',':
	out = PODLOGA;
	break;
    case '>':
	out = ZEJSCIE;
	break;
    case '<':
	out = WEJSCIE;
	break;
    case 'O':
	out = KIBEL;
	break;
    case '_':
	out = OLTARZ;
	break;
    case ' ':
	out = NIC;
	break;
    case 'Y':
	out = DRZEWO;
	break;
    case 'l':
	out = LOZKO;
	break;
    default:
	out = NIC;
	break;
    }
    return out;
}

/*aduje poziom zapisany w starym (human readable formacie) */
void laduj_poziom_old(FILE * plik, struct poziom *Poziom)
{
    int x, y;
    Poziom->maxx = fgetc(plik);
    Poziom->maxy = fgetc(plik);
    Poziom->poczx = fgetc(plik);
    Poziom->poczy = fgetc(plik);
    Poziom->poziom = fgetc(plik);
    fgetc(plik);
    for (y = 0; y < Poziom->maxy; y++) {
	for (x = 0; x < Poziom->maxx; x++) {
	    Poziom->pole[x][y] = tlumacz_char_na_int(fgetc(plik));
	    Poziom->znane[x][y] = 0;
	}

	fgetc(plik);
    }
}


void laduj_poziom(FILE * plik, struct poziom *Poziom)
{
    int x, y;
/*fread(    &Poziom->maxx, sizeof(    Poziom->maxx), 1, plik);
fread(    &Poziom->maxy, sizeof(    Poziom->maxy), 1, plik);
fread(    &Poziom->poczx, sizeof(    Poziom->poczx), 1, plik);
fread(    &Poziom->poczy, sizeof(    Poziom->poczy), 1, plik);
fread(    &Poziom->poziom, sizeof(    Poziom->poziom), 1, plik); */
    Poziom->maxx = fgetc(plik);
    Poziom->maxy = fgetc(plik);
    Poziom->poczx = fgetc(plik);
    Poziom->poczy = fgetc(plik);
    Poziom->poziom = fgetc(plik);
    Poziom->Istoty.maxszybkosc = -1;

    for (y = 0; y < Poziom->maxy; y++) {
	for (x = 0; x < Poziom->maxx; x++) {
	    fread(&Poziom->pole[x][y], sizeof(int), 1, plik);
	    Poziom->znane[x][y] = 0;
	}
    }
}

void zapisz_poziom(FILE * plik, struct poziom *Poziom)
{
    int x, y;
/*    fwrite(&Poziom->maxx, sizeof(Poziom->maxx), 1, plik);
    fwrite(&Poziom->maxy, sizeof(Poziom->maxy), 1, plik);
    fwrite(&Poziom->poczx, sizeof(Poziom->poczx), 1, plik);
    fwrite(&Poziom->poczy, sizeof(Poziom->poczy), 1, plik);
    fwrite(&Poziom->poziom, sizeof(Poziom->poziom), 1, plik); */
     fputc(Poziom->maxx, plik);
     fputc(Poziom->maxy, plik);
     fputc(Poziom->poczx, plik);
     fputc(Poziom->poczy, plik);
     fputc(Poziom->poziom, plik);
    for (y = 0; y < Poziom->maxy; y++) {
	for (x = 0; x < Poziom->maxx; x++)
	    fwrite(&Poziom->pole[x][y], sizeof(int), 1, plik);
    }
}

/* Wczytuje tablic waciwoci przedmiotw */
void wczytaj_tablice_prz_ID(FILE * in, struct PrzedmiotyID *tablica)
{
    int i;
    fread(&tablica->ile, sizeof(tablica->ile), 1, in);
    for (i = 0; i < tablica->ile; i++) {
	fread(&tablica->ID[i], sizeof(struct przedmiotID), 1, in);
    }
}

/* Zapisuje tablic waciwoci przedmiotw */
void zapisz_tablice_prz_ID(FILE * out, struct PrzedmiotyID tablica)
{
    int i;
    fwrite(&tablica.ile, sizeof(tablica.ile), 1, out);
    for (i = 0; i < tablica.ile; i++) {
	fwrite(&tablica.ID[i], sizeof(struct przedmiotID), 1, out);
    }
}

/* Tworzy list przedmiotw w/g tego co w pliku  */
void wczytaj_przedmioty(FILE * in, struct przedmioty *Przedmioty)
{
    int i;
    struct przedmiot_IO rekord;
	fread(&i, sizeof(int), 1, in);
    while (Przedmioty->ile < i) {
	fread(&rekord, sizeof(struct przedmiot_IO), 1, in);
	dodaj_ladnie(rekord.x, rekord.y, rekord.ilosc, rekord.ID, -1, -1,
		     Przedmioty);
    }
}

/* Zapisuje do pliku liste przedmiotw */
void zapisz_przedmioty(FILE * out, struct przedmioty *Przedmioty)
{
    int i;
    struct przedmiot_IO rekord;
	fwrite(&Przedmioty->ile, sizeof(Przedmioty->ile), 1, out);
    i = 0;
    if (Przedmioty->ile < 1) {
	return;
    }
    Przedmioty->aktualny = Przedmioty->poczatek;
    while (i < Przedmioty->ile) {
	Przedmioty->aktualny = Przedmioty->aktualny->nast;
	rekord.x = Przedmioty->aktualny->x;
	rekord.y = Przedmioty->aktualny->y;
	rekord.ID = Przedmioty->aktualny->ID;
	rekord.ilosc = Przedmioty->aktualny->ilosc;
	fwrite(&rekord, sizeof(struct przedmiot_IO), 1, out);
	i++;
    }
}
void wczytaj_tablice_potw_ID(FILE * in, struct PotworyID *tablica)
{
    int i;
fread(&tablica->ile, sizeof(tablica->ile), 1, in);
    i = 0;
    while (i < tablica->ile) {
	fread(&tablica->ID[i], sizeof(struct potworID), 1, in);
	i++;
    }
}

/* Zapisuje tablic opisujc potwory */
void zapisz_tablice_potw_ID(FILE * out, struct PotworyID *tablica)
{
    int i;
	fwrite(&tablica->ile, sizeof(tablica->ile), 1, out);
    i = 0;
    while (i < tablica->ile) {
	fwrite(&tablica->ID[i], sizeof(struct potworID), 1, out);
	i++;
    }
}

void wczytaj_potwory(FILE * in, struct istoty *Istoty)
{
    int i, j;
    struct istota_IO rekord;
	fread(&i, sizeof(int), 1, in);
    while (Istoty->ile < i + 1) {
	fread(&rekord, sizeof(struct istota_IO), 1, in);
	dodaj_postac(rekord.x, rekord.y, rekord.ID, rekord.flagi,
		     Poziom.poziom, Istoty);
	Istoty->aktualny->typ = rekord.typ;
	Istoty->aktualny->kolor = rekord.kolor;
	for (j = 0; j < 50; j++)
	    Istoty->aktualny->umiejetnosci[j] = rekord.umiejetnosci[j];
	for (j = 0; j < ILOSC_WSPOLCZYNNIKOW; j++)
	    Istoty->aktualny->wspolczynniki[j] = rekord.wspolczynniki[j];
    }
}
void zapisz_potwory(FILE * out, struct istoty *Istoty)
{
    int i, j, tmp=Istoty->ile - 1;
    struct istota_IO rekord;
	fwrite(&tmp, sizeof(int),1, out);
    i = 0;
    if (Istoty->ile < 2) {
	return;
    }
/* Ustawiamy wskaznik na gracza */
    Istoty->aktualny = Istoty->poczatek->nast;
    while (i < (Istoty->ile - 1)) {
	Istoty->aktualny = Istoty->aktualny->nast;
	rekord.x = Istoty->aktualny->x;
	rekord.y = Istoty->aktualny->y;
	rekord.kolor = Istoty->aktualny->kolor;
	strcpy(rekord.nazwa, Istoty->aktualny->nazwa);
	strcpy(rekord.nazwa_dop, Istoty->aktualny->nazwa_dop);
	rekord.ID = Istoty->aktualny->ID;
	rekord.flagi = Istoty->aktualny->flagi;
	rekord.typ = Istoty->aktualny->typ;
	for (j = 0; j < 50; j++)
	    rekord.umiejetnosci[j] = Istoty->aktualny->umiejetnosci[j];
	for (j = 0; j < ILOSC_WSPOLCZYNNIKOW; j++)
	    rekord.wspolczynniki[j] = Istoty->aktualny->wspolczynniki[j];
	fwrite(&rekord, sizeof(struct istota_IO), 1, out);
	i++;
    }
}

/*--------------------------------A dotd */

void wczytaj_potwory_kr(FILE * in, struct istoty *Istoty)
{
    int i;
    struct istota_IO_krotka rekord;
fread(&i, sizeof(int),1,in);
    while (Istoty->ile < i + 1) {
	fread(&rekord, sizeof(struct istota_IO_krotka), 1, in);
	dodaj_postac(rekord.x, rekord.y, rekord.ID, 0, Poziom.poziom,
		     Istoty);
    }

}

void zapisz_potwory_kr(FILE * out, struct istoty *Istoty)
{
    int i, tmp = Istoty->ile - 1;
    struct istota_IO_krotka rekord;
	fwrite(&tmp, sizeof(int), 1, out);
    i = 0;
    if (Istoty->ile < 2) {
	return;
    }
/* Ustawiamy wskaznik na gracza */
    Istoty->aktualny = Istoty->poczatek->nast;
    while (i < (Istoty->ile - 1)) {
	Istoty->aktualny = Istoty->aktualny->nast;
	rekord.x = Istoty->aktualny->x;
	rekord.y = Istoty->aktualny->y;
	rekord.ID = Istoty->aktualny->ID;
	fwrite(&rekord, sizeof(struct istota_IO_krotka), 1, out);
	i++;
    }
}

/*void
   zabij_potwora (struct istoty *Istoty, struct poziom *Poziom)
   {
   return;
   } */

void rysuj_poziom(struct poziom *Poziom)
{
    int x, y;
    char znak;
    znak = '?';
    wmove(wPoziom, 0, 0);
    for (y = Poziom->sy; y <= Poziom->ky; y++) {
	wmove(wPoziom, y - Poziom->sy, 0);
	for (x = Poziom->sx; x <= Poziom->kx; x++)
	    if (x < Poziom->maxx && x >= 0 && y < Poziom->maxy && y >= 0) {
		if (Poziom->znane[x][y]) {
		    switch (Poziom->pole[x][y]) {
		    case TRAWA:
			zmien_kolor(K_ZIELONY, wPoziom);
			znak = '"';
			break;
		    case WODA:
			zmien_kolor(K_NIEBIESKI, wPoziom);
			znak = '~';
			break;
		    case DRZWI_ZAMKNIETE_NA_KLUCZ:
		    case DRZWI_ZAMKNIETE:
			zmien_kolor(K_BRAZOWY, wPoziom);
			znak = '+';
			break;
		    case DRZWI_OTWARTE:
			zmien_kolor(K_BRAZOWY, wPoziom);
			znak = '/';
			break;
		    case DROGA:
			zmien_kolor(K_BRAZOWY, wPoziom);
			znak = '.';
			break;
		    case PODLOGA:
			zmien_kolor(K_SZARY, wPoziom);
			znak = '.';
			break;
		    case ZEJSCIE:
			zmien_kolor(K_BIALY, wPoziom);
			znak = '>';
			break;

		    case WEJSCIE:
			zmien_kolor(K_BIALY, wPoziom);
			znak = '<';
			break;
		    case MUR:
			zmien_kolor(K_SZARY, wPoziom);
			znak = '#';
			break;
		    case KIBEL:
			zmien_kolor(K_B_BIALY, wPoziom);
			znak = 'O';
			break;
		    case OLTARZ:
			zmien_kolor(K_B_BIALY, wPoziom);
			znak = '_';
			break;
		    case DRZEWO:
			zmien_kolor(K_ZIELONY, wPoziom);
			znak = 'Y';
			break;
		    case LOZKO:
			zmien_kolor(K_SZARY, wPoziom);
			znak = '=';
			break;
		    default:
			zmien_kolor(K_CZERWONY, wPoziom);
			znak = '?';
		    }
		    waddch(wPoziom, znak);
		} else
		    waddch(wPoziom, ' ');
	    }
    }
}

/* Zamienia jedno pole poziomu na jakie inne
 * (np. drzwi zamknite na otwarte) */
void zmien_poziom(struct poziom *Poziom, int x, int y, int jak)
{
    Poziom->pole[x][y] = jak;
}

void zmien_kolor(int kolor, WINDOW * okno)
{
    int atryb;
    wattroff(okno, WA_DIM | WA_BOLD | WA_BLINK);
    switch (kolor) {
    case K_ZIELONY:
	atryb = (COLOR_PAIR(K_ZIELONY) | WA_NORMAL);
	break;
    case K_NIEBIESKI:
	atryb = (COLOR_PAIR(K_NIEBIESKI) | WA_BOLD);
	break;
    case K_BRAZOWY:
	atryb = (COLOR_PAIR(K_BRAZOWY) | WA_NORMAL);
	break;
    case K_BIALY:
	atryb = (COLOR_PAIR(K_BIALY) | WA_NORMAL);
	break;
    case K_ZOLTY:
	atryb = (COLOR_PAIR(K_BRAZOWY) | WA_BOLD);
	break;
    case K_SZARY:
	atryb = (COLOR_PAIR(K_BIALY) | WA_DIM);
	break;
    case K_CZERWONY:
	atryb = (COLOR_PAIR(K_CZERWONY) | WA_NORMAL);
	break;
    case K_FIOLETOWY:
	atryb = (COLOR_PAIR(K_FIOLETOWY) | WA_NORMAL);
	break;
    case K_B_BIALY:
	atryb = (COLOR_PAIR(K_BIALY) | WA_BOLD);
	break;
    default:
	atryb = 0;
	break;
    }
    wattron(okno, atryb);
}

void zakoncz()
{
    return;
}

void wyswietl_kratke(int kolor)
{
    char znak;
    switch (kolor) {
    case TRAWA:
	zmien_kolor(K_ZIELONY, wGora);
	znak = '"';
	break;
    case WODA:
	zmien_kolor(K_NIEBIESKI, wGora);
	znak = '~';
	break;
    case DRZWI_ZAMKNIETE_NA_KLUCZ:
    case DRZWI_ZAMKNIETE:
	zmien_kolor(K_BRAZOWY, wGora);
	znak = '+';
	break;
    case DRZWI_OTWARTE:
	zmien_kolor(K_BRAZOWY, wGora);
	znak = '/';
	break;
    case DROGA:
	zmien_kolor(K_BRAZOWY, wGora);
	znak = '.';
	break;
    case PODLOGA:
	zmien_kolor(K_SZARY, wGora);
	znak = '.';
	break;
    case ZEJSCIE:
	zmien_kolor(K_BIALY, wGora);
	znak = '>';
	break;
    case WEJSCIE:
	zmien_kolor(K_BIALY, wGora);
	znak = '<';
	break;
    case MUR:
	zmien_kolor(K_SZARY, wGora);
	znak = '#';
	break;
    case KIBEL:
	zmien_kolor(K_B_BIALY, wGora);
	znak = 'O';
	break;
    case OLTARZ:
	zmien_kolor(K_B_BIALY, wGora);
	znak = '_';
	break;
    case DRZEWO:
	zmien_kolor(K_ZIELONY, wGora);
	znak = 'Y';
	break;
    default:
	zmien_kolor(K_CZERWONY, wGora);
	znak = '?';
    }
    waddch(wGora, znak);
}

void wyczysc_trasy()
{
    int i, j;
    for (i = 0; i < MAXPOTWOROW; i++)
	for (j = 0; j < MAXTRAS; j++) {
	    trasa.m[i][j] = 0;
	    trasa.a[i] = -1;
	    strcpy(trasa.c[i][j], "");
	}
}


void wyczysc_pulapki()
{
    int i, j;
    for (i = 0; i < MAXX; i++)
	for (j = 0; j < MAXY; j++) {
	    pulapka[i][j].typ = PUL_BRAK;
	    pulapka[i][j].prob_wykrycia = 0;
	}
}


void laduj_pulapki(struct _plik *in)
{
}

void zapisz_pulapki(char *out, long int *dl)
{
}
